﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;

namespace sunflower
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            //CheckForIllegalCrossThreadCalls = false;
            
        }
        private void Form1_Load(object sender, EventArgs e)
        {         
            string[] ports = SerialPort.GetPortNames();
            for (int i = 0; i < ports.Length; i++)
            {
                if (ports[i].Length > 5)
                {
                    ports[i] = ports[i].Substring(0, 5);

                }

                comboBox1.Items.Add(ports[i]);
            }
            if (ports.Length > 0)
            {
              comboBox1.SelectedIndex = 0;
             
            }
            //MessageBox.Show(comboBox1.Text);
            Program.portname = comboBox1.Text;
            Program.baudrate = 115200;
            Program.databits = 8;
            Program.stopbits = StopBits.One;
            Program.parity = Parity.None;
           
        }

        private bool isConect = false;



        double F_height;
        double H_height;
        double H1_height;
        bool listening = false;
        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            if (isConect)
            {
                try
                {
                    listening = true;
                    serialPort1.ReadTimeout = 10000;
                    //MessageBox.Show("数据接收成功");
                    //string text = string.Empty;
                    //byte[] data = new byte[serialPort1.BytesToRead];

                    string strs = serialPort1.ReadLine().Trim();
                    //MessageBox.Show(strs);
                    string[] str = strs.Split(",".ToCharArray());
                    for (int i = 0; i < str.Length; i++)
                    {
                        str[i] = str[i];
                        //MessageBox.Show(str[i]);
                    }

                    F_height = Convert.ToDouble(str[0]);
                    H_height = Convert.ToDouble(str[1]);
                    H1_height = Convert.ToDouble(str[2]);


                    if (str[4] == "ff")
                    {
                        toolStripStatusLabel6.Text = "水泵";
                        toolStripStatusLabel8.Text = "湿度传感器";

                    }
                    else if (str[4] == "f0")
                    {
                        toolStripStatusLabel6.Text = "电磁阀";
                        toolStripStatusLabel8.Text = "湿度传感器";

                    }
                    else if (str[4] == "0f")
                    {
                        toolStripStatusLabel6.Text = "水泵";
                        toolStripStatusLabel8.Text = "碳棒";
                    }
                    else if (str[4] == "00")
                    {
                        toolStripStatusLabel6.Text = "电磁阀";
                        toolStripStatusLabel8.Text = "碳棒";
                    }

                    //MessageBox.Show(F_height.ToString() + " " + H_height.ToString() + " " + H1_height.ToString());
                    label4.Invoke(new MethodInvoker(delegate { label4.Text = F_height.ToString(); }));
                    label6.Invoke(new MethodInvoker(delegate { label6.Text = H_height.ToString(); }));
                    label2.Invoke(new MethodInvoker(delegate { label2.Text = H1_height.ToString(); }));
                    label3.Invoke(new MethodInvoker(delegate { label3.Text = str[3]; }));
                    //跨线程
                    panel1.Invoke(new MethodInvoker(delegate { panel1.Height = Convert.ToInt32(F_height); }));
                    panel2.Invoke(new MethodInvoker(delegate { panel2.Height = Convert.ToInt32(H_height); }));
                    panel3.Invoke(new MethodInvoker(delegate { panel3.Height = Convert.ToInt32(H1_height); }));

                    panel1.Invoke(new MethodInvoker(delegate { panel1.Location = new Point(475, Convert.ToInt32(298 - F_height)); }));
                    panel2.Invoke(new MethodInvoker(delegate { panel2.Location = new Point(526, Convert.ToInt32(300 - H_height)); }));
                    panel3.Invoke(new MethodInvoker(delegate { panel3.Location = new Point(132, Convert.ToInt32(212 - H1_height)); }));
                }
                catch { }
                finally
                {
                    listening = false;
                    
                }
            }
        }
 

        private void pictureBox7_Click(object sender, EventArgs e)
        {
            if (!isConect)
            {
                PortSet(Program.portname, Program.baudrate, Program.databits, Program.stopbits, Program.parity);
                PortOpen();
                isConect = true;
                pictureBox7.Image = Image.FromFile(@"img\断开.png");
                Thread.Sleep(200);
                toolStripStatusLabel2.Text = Program.portname;
                toolStripStatusLabel4.Text = Program.baudrate.ToString();
                toolStripStatusLabel9.ForeColor = Color.Green;
                toolStripStatusLabel9.Text = " 已连接  ";
                panel1.Visible = true;
                panel2.Visible = true;
                panel3.Visible = true;
                label4.Visible = true;
                label6.Visible = true;
                label2.Visible = true;
                label3.Visible = true;
                label1.Visible = true;
            }
            else
            {
                while (listening)
                {
                    Application.DoEvents();
                   
                }
                PortClose();
                isConect = false;
                pictureBox7.Image = Image.FromFile(@"img\链接.png");
                panel1.Visible = false;
                panel2.Visible = false;
                panel3.Visible = false;
                label4.Visible = false;
                label6.Visible = false;
                label2.Visible = false;
                label3.Visible = false;
                label1.Visible = false;
                toolStripStatusLabel9.ForeColor = Color.Red;
                toolStripStatusLabel9.Text = " 未连接  ";

            }
        }
    
        private void pictureBox8_Click(object sender, EventArgs e)
        {
            PortClose();
            isConect = false;
            pictureBox7.Image = Image.FromFile(@"img\链接.png");
            panel1.Visible = false;
            panel2.Visible = false;
            panel3.Visible = false;
            label1.Visible = false;
            label3.Visible = false;
            label4.Visible = false;
            label6.Visible = false;
            label2.Visible = false;
            Form2 frm2 = new Form2();
            frm2.ShowDialog();
        }


        public void PortSet(string portname, int baudrate, int databits, StopBits stopbits, Parity parity)
        {
           serialPort1.PortName = portname;
           serialPort1.BaudRate = baudrate;
           serialPort1.DataBits = databits;
           serialPort1.StopBits = stopbits;
           serialPort1.Parity = parity;
        }

        public void PortOpen()
        {
            serialPort1.Open();
        }

        public void PortClose()
        {

            serialPort1.Close();
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (comboBox6.Text == "水泵" && comboBox7.Text == "湿度传感器")
            {
                Program.sb_2 = 0xff;
                Program.jy = 0xff;
            }
            else if ((comboBox6.Text == "水泵" && comboBox7.Text == "碳棒") )
            {
                Program.sb_2 = 0x0f;
                Program.jy = 0x0e;
            }
            else if (comboBox6.Text == "电磁阀" && comboBox7.Text == "湿度传感器")
            {
                Program.sb_2 = 0xf0;
                Program.jy = 0xef;
            }
            else if ((comboBox6.Text == "电磁阀" && comboBox7.Text == "碳棒"))
            {
                Program.sb_2 = 0x00;
                Program.jy = 0xff;
            }
            byte[] cmd = new byte[5];
            cmd[0] = 0x55;
            cmd[1] = 0xAA;
            cmd[2] = 0x00;
            cmd[3] = Program.sb_2;
            cmd[4] = Program.jy;
            while (listening)
            {
                Application.DoEvents();
            }
            for (int i = 0; i < cmd.Length; i++)
            {

                serialPort1.Write(cmd, i, 1);
            }
        }

        private void comboBox6_SelectedIndexChanged(object sender, EventArgs e)
        {
            //if (comboBox6.Text == "水泵")
            //{
            //    Program.sb_1 = 0x00;
            //}
            //else
            //{
            //    Program.sb_1 = 0x01;
            //}
        }

        private void comboBox7_SelectedIndexChanged(object sender, EventArgs e)
        {
            //if (comboBox7.Text == "湿度传感器")
            //{
            //    Program.sb_2 = 0x00;
            //}
            //else
            //{
            //    Program.sb_2 = 0x01;
            //}
        }

    }
}
